;;====================================================================
;; gdm_m1_helicoil.lsp
;; os / 06.02.2007 15:11
;;====================================================================

(in-package  :GDM)
(use-package :OLI)

(sd-defdialog 'gdm-m1-helicoil-dialog
  :dialog-title "HELICOIL plus"
  :toolbox-button t
  :variables
  '(
    (BILD
     :value-type :image
;	 :image-file (format nil "~a/LISP/gdm_m1_helicoil.bmp" (oli::sd-convert-filename-from-platform (oli::sd-sys-getenv "SDCORPCUSTOMIZEDIR"))))
     :image-file "C:/ ... PFAD ANPASSEN ... /gdm_m1_helicoil.bmp")

    (DATENBLATT
;     :push-action (sd-display-url (format nil "file:~a/LISP/gdm_m1_helicoil.mht" (oli::sd-convert-filename-from-platform (oli::sd-sys-getenv "SDCORPCUSTOMIZEDIR"))))
	 :push-action (sd-display-url "C:/ ... PFAD ANPASSEN ... /gdm_m1_helicoil.mht")
     :title (sd-multi-lang-string "Show Data Sheet" :german "Datenblatt zeigen")
     :toggle-type :wide-toggle)

    ("")
    (AKT_PART
     :value-type :part-incl-new
     :modifies :contents
     :title (sd-multi-lang-string "Part" :german "Teil")
     :prompt-text (sd-multi-lang-string "Specify Part." :german "Teil angeben."))

    (AKT_WP
     :value-type :wp
     :title (sd-multi-lang-string "Workplane" :german "AEbene")
     :prompt-text (sd-multi-lang-string "Specify Workplane" :german "ArbeitsEbene angeben."))

    ("")
    (GEWINDE_D
     :range ("M2,5" "M3" "M4" "M5" "M6" "M8")
     :title (sd-multi-lang-string "Thread Diam" :german "Gewinde Durchm")
     :after-input
      (progn
        (os-init-action)
        (cond
          ((string= GEWINDE_D "M2")   (setf L_GEWINDE 2.0))
          ((string= GEWINDE_D "M2,5") (setf L_GEWINDE 2.5))
          ((string= GEWINDE_D "M3")   (setf L_GEWINDE 3.0))
          ((string= GEWINDE_D "M4")   (setf L_GEWINDE 4.0))
          ((string= GEWINDE_D "M5")   (setf L_GEWINDE 5.0))
          ((string= GEWINDE_D "M6")   (setf L_GEWINDE 6.0))
          ((string= GEWINDE_D "M8")   (setf L_GEWINDE 8.0))
        );;cond
      );;progn
     :prompt-text (sd-multi-lang-string "Specify Thread Diameter." :german "Gewindedurchmesser angeben."))

    (DHC
     :value-type :display-only
     :title "DHC")

    (D1HC
     :value-type :display-only
     :title "D1HC")

    ("")

    (SACKL :expand-shrink (GEW_A_R GEW_A_K GEW_A_L E0 L_GEWINDE BOHR_TIEFE)
           :expand-shrink-toggle-type :boolean :title (sd-multi-lang-string "Blind Hole" :german "Sacklochbohrung"))

    (GEW_A_R :value-type :grouped-boolean :size :third
             :title (sd-multi-lang-string "Regular" :german "Regelf.") :after-input (os-init-action) :initial-value t)

    (GEW_A_K :value-type :grouped-boolean :size :third
             :title (sd-multi-lang-string "short" :german "kurz") :after-input (os-init-action))

    (GEW_A_L :value-type :grouped-boolean :size :third
             :title (sd-multi-lang-string "long" :german "lang") :after-input (os-init-action))

    (E1);; Regelgewindeauslauf

    (E2);; Gewindeauslauf kurz

    (E3);; Gewindeauslauf lang

    (E0
     :value-type :display-only
     :title "e1; e2; e3")

    (L_GEWINDE
     :value-type :positive-number
     :initial-value 2.5
     :title "t2"
     :after-input (os-init-action)
     :prompt-text (sd-multi-lang-string "Specify Nominal Length t2." :german "Nennlaenge des Gewindeeinsatzes t2 angeben."))

    (BOHR_TIEFE
     :value-type :display-only
     :title "t1")

    ("")

    (PKT
     :value-type :point-3d
     :title (sd-multi-lang-string "Point" :german "Punkt")
     :prompt-text (sd-multi-lang-string "Specify Point." :german "Punkt angeben."))

    ("")

    (NEXT
     :title "Next"
     :push-action
      (progn
        (os-helicoil-gewinde-erstellen)
        (setf PKT nil)
      );;progn
     :next-variable 'PKT)

  );;variables

  :mutual-exclusion '( (GEW_A_R GEW_A_K GEW_A_L))

  :after-initialization '(os-init-action)

  :local-functions
  '(
    (os-init-action ()
      (cond
       ((string= GEWINDE_D "M2")   (setf DHC 2.52    D1HC 2.18  E1 2.30  E2 (* 0.37 E1)  E3 (* 1.50 E1) STEIGUNG 0.4  ))
       ((string= GEWINDE_D "M2,5") (setf DHC 3.08    D1HC 2.70  E1 2.60  E2 (* 0.37 E1)  E3 (* 1.50 E1) STEIGUNG 0.45 ))
       ((string= GEWINDE_D "M3")   (setf DHC 3.65    D1HC 3.22  E1 2.80  E2 (* 0.37 E1)  E3 (* 1.50 E1) STEIGUNG 0.5  ))
       ((string= GEWINDE_D "M4")   (setf DHC 4.91    D1HC 4.29  E1 3.80  E2 (* 0.37 E1)  E3 (* 1.50 E1) STEIGUNG 0.7  ))
       ((string= GEWINDE_D "M5")   (setf DHC 6.04    D1HC 5.33  E1 4.20  E2 (* 0.37 E1)  E3 (* 1.50 E1) STEIGUNG 0.8  ))
       ((string= GEWINDE_D "M6")   (setf DHC 7.30    D1HC 6.41  E1 5.10  E2 (* 0.37 E1)  E3 (* 1.50 E1) STEIGUNG 1.0  ))
       ((string= GEWINDE_D "M8")   (setf DHC 9.62    D1HC 8.48  E1 6.20  E2 (* 0.37 E1)  E3 (* 1.50 E1) STEIGUNG 1.25 ))
      );;cond
      (if (and GEW_A_R SACKL)
          (setf E0 E1 BOHR_TIEFE (+ L_GEWINDE E0))
      );;if
      (if (and GEW_A_K SACKL)
          (setf E0 E2 BOHR_TIEFE (+ L_GEWINDE E0))
      );;if
      (if (and GEW_A_L SACKL)
          (setf E0 E3 BOHR_TIEFE (+ L_GEWINDE E0))
      );;if

    );;os-init-action

    (os-helicoil-gewinde-erstellen ()
      (sd-call-cmds
       (progn
         (let (FLAECHEN_LISTE FLAECHEN_LISTE_NEW A_FLAECHE KANTEN A_KANTE) 
          (os-init-action)
          ;; aktuelle WP kopieren und GEO loeschen
          (sd-call-cmds (create_workplane :copy :source AKT_WP :name "AE_tmp" :owner "/"))
          (sd-call-cmds (delete_2d :current_wp :edge_2d :all_2d) :failure nil)
          (sd-call-cmds (position_wp :workplane (sd-inq-curr-wp) :translate :two_ptv (sd-inq-wp-origin (sd-inq-curr-wp)) PKT))
          ;; Alle Zylinderflaechen sammeln
          (setf FLAECHEN_LISTE (sd-call-cmds (get_selection	:focus_type *sd-cylinder-seltype* :select :in_part (sd-inq-curr-part))))
          (if SACKL
              (os-helicoil-sacklochbohrung)
              (os-helicoil-durchgangsbohrung)
          );;if
          ;; Alle Zylinderflaechen nach dem Bohren sammeln
          (sd-call-cmds (get_selection	:focus_type *sd-cylinder-seltype* :select :in_part (sd-inq-curr-part))
                                        :failure (setf FLAECHEN_LISTE_NEW nil)
                                        :success (setf FLAECHEN_LISTE_NEW *SD-ACTION-RESULT*))
          ;; Liste 1 und 2 vergleichen; neu Flaechen pruefen (Gewinde ja/nein); Gewindeinformation erstellen
          (if (null FLAECHEN_LISTE_NEW)
              (sd-display-message
                 (sd-multi-lang-string "Error! There are no new Surfaces." :german "Fehler! Das Modell hat keine neuen Flaechen."))
              (dolist (A_FLAECHE FLAECHEN_LISTE_NEW)
                (when (not (member A_FLAECHE FLAECHEN_LISTE :test #'equal))
                  (sd-call-cmds (get_selection :focus_type *sd-circle-3d-seltype* :select :by_face A_FLAECHE)
                                 :failure nil
                                 :success (setf KANTEN *SD-ACTION-RESULT*))

                  (unless (null KANTEN)
                    (let (NEBENFLAECHEN RICHTUNG)
                         (dolist (A_KANTE KANTEN)
                            (sd-call-cmds (get_selection :focus_type *sd-plane-seltype* :select :by_edge_3d A_KANTE)
                                           :failure (setf NEBENFLAECHEN nil)
                                           :success (setf NEBENFLAECHEN *SD-ACTION-RESULT*))
                            (when NEBENFLAECHEN
                                  (setf RICHTUNG (sd-cylinder-axis-dir (sd-inq-geo-props A_FLAECHE :dest-space :global)))
                                  (sd-call-cmds
                                     (sd-define-thread A_FLAECHE
                                         :nominal-diameter DHC
                                         :core-diameter D1HC
                                         :pitch STEIGUNG
                                         :thread-type :INNER
                                         :thread-unit :METRIC
                                         :thread-color (sd-color-to-rgb 16753049)
                                         :thread-hand :RIGHT-HAND
                                         :thread-profile :HELICOIL
                                         :include-chamfer T
                                         :thread-direction RICHTUNG
                                         :thread-name (format nil "~a-HELICOIL" GEWINDE_D)
                                     );;sd-define-thread
                                  );;sd-call-cmds
                                  (sd-call-cmds (chamfer :distance (/ (- DHC D1HC) 2) A_KANTE))
                            );;when
                         );;dolist
                    );;let
                  );;unless

                );;when
              );;dolist
         );;if 
         ;;Urspungs AE aktiv setzen
         (sd-call-cmds (current_wp AKT_WP) :failure nil)
        );;let
       );;progn
      );;sd-call-cmds
    );;os-helicoil-gewinde-erstellen

    (os-helicoil-sacklochbohrung ()
       (let (P1 P2 P3 P4 W_FAKT)
          ;; WP um 90 Grad drehen
          (sd-call-cmds (position_wp :workplane (sd-inq-curr-wp) :rotate :axis :u :rotation_angle (/ pi 2) :done))
          ;;Punkte berechnen
          ;;   P1  P2
          ;;    *--*
          ;;    |  |
          ;;    |__|P3
          ;;    | /
          ;;    */
          ;;    P4 
          (setf P1 (gpnt2d 0 1))
          (setf P2 (gpnt2d (/ D1HC 2) 1))
          (setf P3 (gpnt2d (/ D1HC 2) (* -1 BOHR_TIEFE)))
          (setf W_FAKT (tan (* (/ (* 2 pi) 360.0) 31.0)))
          (setf P4 (gpnt2d 0 (* -1 (+ BOHR_TIEFE (* (/ D1HC 2.0) W_FAKT)))))
          ;;Profil erstellen
          (geometry_mode :real)
          (sd-call-cmds (polygon P1 P2 P3 P4 P1))
          ;; Abdrehen und Profil loeschen
          (sd-call-cmds (bore :parts AKT_PART :wp (sd-inq-curr-wp) :axis :v :rotation_angle (* 2 pi) :keep_wp :yes :keep_profile :no))
          ;; Arbeitsebene um 90 Grad drehen und um die Gewindelaenge verschieben  
          (sd-call-cmds (position_wp :workplane (sd-inq-curr-wp) :rotate :axis :u :rotation_angle (/ pi 2)))
          (sd-call-cmds (position_wp :workplane (sd-inq-curr-wp) :translate :dir_len :w :len L_GEWINDE))
          ;; Geo fuer Gewindelaenge erstellen
          (sd-call-cmds (circle :cen_rad 0,0 (/ D1HC 2)))
          ;;Kreis praegen
          (sd-call-cmds (imprint_linear :auto_direction :yes :imprint_part (sd-inq-curr-part) :imprint_wp (sd-inq-curr-wp) :imprint_to_part :imprint_keep_wp :off) :failure nil)
       );;let
    );;os-helicoil-sacklochbohrung

    (os-helicoil-durchgangsbohrung ()
          ;;Profil erstellen
          (geometry_mode :real)
          (sd-call-cmds (circle :cen_rad 0,0 (/ D1HC 2)))
          (sd-call-cmds (punch :parts AKT_PART :wp (sd-inq-curr-wp) :keep_wp :no))
    );;os-helicoil-durchgangsbohrung

  );;local-functions

  :ok-action '(os-helicoil-gewinde-erstellen)
  
);;sd-defdialog
